﻿using Syncfusion.UI.Xaml.RichTextBoxAdv;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace RTE_UWP
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            richTextBoxAdv.Document.Sections[0].Blocks.Clear();
            richTextBoxAdv.Document.Sections[0].Blocks.Add(CreateTable());

            TableAdv firstTable = richTextBoxAdv.Document.Sections[0].Blocks[0] as TableAdv;
            //Get the text position of second row, first cell, first paragraph 
            ParagraphAdv startParagraph = firstTable.Rows[1].Cells[0].Blocks[0] as ParagraphAdv;
            TextPosition beg = richTextBoxAdv.Document.GetTextPosition(startParagraph, 0);

            //Get the text position of second row, second cell, first paragraph
            ParagraphAdv endParagraph = firstTable.Rows[1].Cells[1].Blocks[0] as ParagraphAdv;
            TextPosition end = richTextBoxAdv.Document.GetTextPosition(endParagraph, 0);

            //Selects the specified start and end position
            richTextBoxAdv.Selection.Select(beg, end);
            richTextBoxAdv.MergeSelectedCellsCommand.Execute(null);

            richTextBoxAdv.Focus(FocusState.Programmatic);
        }

        private CellFormat GetCellFormat()
        {
            Borders borders = new Borders();
            Syncfusion.UI.Xaml.RichTextBoxAdv.Border border = new Syncfusion.UI.Xaml.RichTextBoxAdv.Border();
            border.LineStyle = LineStyle.Single;
            border.LineWidth = 0.6;
            borders.Bottom = border;
            borders.Top = border;
            borders.Left = border;
            borders.Right = border;
            CellFormat cellFormat = new CellFormat();
            cellFormat.CellWidth = 250;
            cellFormat.Borders = borders;
            return cellFormat;
        }

        private TableAdv CreateTable()
        {
            TableAdv table = new TableAdv();
            for (int i = 0; i < 3; i++)
            {
                TableRowAdv row = new TableRowAdv();
                for (int j = 0; j < 2; j++)
                {
                    TableCellAdv cell = new TableCellAdv();
                    ParagraphAdv paragraphAdv = new ParagraphAdv();
                    SpanAdv spanAdv = new SpanAdv();
                    spanAdv.Text = "R" + i + "C" + j;
                    paragraphAdv.Inlines.Add(spanAdv);
                    cell.Blocks.Add(paragraphAdv);

                    cell.CellFormat = GetCellFormat();
                    row.Cells.Add(cell);
                }
                table.Rows.Add(row);
            }
            return table;
        }
    }
}
